## ros-one-eus-qp 0.1.18-14jammy.20251023.0133

=== CMakeLists.txt ===
project(eus_qp)

cmake_minimum_required(VERSION 2.4.6)

find_package(catkin COMPONENTS cmake_modules rostest)
find_package(Eigen REQUIRED)

include_directories(${Eigen_INCLUDE_DIRS})
include_directories(${EIGEN_INCLUDE_DIRS})

include_directories(${PROJECT_SOURCE_DIR}/include)
include_directories(${PROJECT_SOURCE_DIR}/3rdparty)
include_directories(${PROJECT_SOURCE_DIR}/src)
include("./path-tricker/includes.txt")

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)

catkin_package()

add_executable(euq_qp_test src/example.cpp)
add_library(eus_qp SHARED src/qp_lib.cpp)

if(CATKIN_ENABLE_TESTING)
  add_rostest(test/test_contact_wrench_opt.test)
  add_rostest(test/test_model_predictive_control.test)
  add_rostest(test/test_cfr_cwc_calculation.test)
  add_rostest(optmotiongen/test/test-sample-inverse-kinematics.test)
  add_rostest(optmotiongen/test/test-sample-inverse-kinematics-statics.test)
  add_rostest(optmotiongen/test/test-samplerobot.test)
  add_rostest(optmotiongen/test/test-sample-torque-gradient.test)
  add_rostest(optmotiongen/test/test-load-euslisp-files.test)
endif()

install(DIRECTORY euslisp test
  USE_SOURCE_PERMISSIONS
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})
install(TARGETS eus_qp
  DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
install(DIRECTORY optmotiongen/euslisp optmotiongen/scripts optmotiongen/test
  USE_SOURCE_PERMISSIONS
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/optmotiongen)

=== optmotiongen/manual/Makefile ===
TMPDIR := $(shell mktemp -d)
FIGDIR := ${TMPDIR}/fig
EUSFILES = instant-configuration-task trajectory-configuration-task sqp-optimization robot-object-environment instant-manipulation-configuration-task bspline-fundamental bspline-configuration-task extended-joint-link contact-kinematics robot-environment torque-gradient inverse-kinematics-wrapper sqp-msc-optimization bspline-dynamic-configuration-task discrete-kinematics-configuration-task
EUSFILESDIR = "../euslisp"

# IMAGE_FILES := $(shell find ${FIGDIR} -name "*.(jpg|png)" | sed s/jpg/bb/g)

# BB_FILES = $(patsubst %.jpg,%.bb,$(IMAGE_FILES))

# .SUFFIXES: .txt .tex .bbl .bb .jpg .JPG .png .PNG .bmp .BMP .pdf

# .jpg.bb:
# 	ebb -b $<

all: pdf
	rm -fr ${TMPDIR}

copy_eus_tex:
	exit
	-mkdir -p ${TMPDIR}/fig
	# cp ../eus/doc/jlatex/*.tex ${TMPDIR}
	cp jlatex/*.sty ${TMPDIR}
	# cp -r ../eus/doc/jlatex/fig/* ./fig/* ${TMPDIR}/fig/
	# for x in ${TMPDIR}/fig/*.jpg; do ebb -b $$x; extractbb $$x;done
	cp *.tex ${TMPDIR}
	platex --version | grep utf8 || nkf --in-place -e ${TMPDIR}/*.tex
	for x in ${EUSFILES}; do\
		sed "s@\\\\@\\\\\\\\@g" ${EUSFILESDIR}/$$x.l > ${TMPDIR}/$$x.l; \
		roseus ./documentation.l "(make-document \"${TMPDIR}/$$x.l\" \"${TMPDIR}/$$x.tex\")" "(exit)"; \
	done

toc: copy_eus_tex
	(cd ${TMPDIR}; makeindex manual.tex)

dvi: toc
	(cd ${TMPDIR}; platex manual.tex)
	(cd ${TMPDIR}; platex manual.tex)
	cp ${TMPDIR}/*.dvi .

pdf: dvi
	(cd ${TMPDIR}; dvipdfmx manual.dvi)
	cp ${TMPDIR}/*.pdf .


clean:
	rm -f *~ *.aux *.idx *.log *.toc *.out *.ind *.ilg

distclean: clean
	rm -f *.dvi *.pdf

open:
	gnome-open manual.pdf

watch:
	$(MUTE)CHANGE=true &&                            \
	while true ; do                                  \
          if $$CHANGE ; then                             \
	    for i in ${EUSFILES} ; do                    \
	      touch .$$i -r ${EUSFILESDIR}/$$i.l;        \
	    done;                                        \
	    CHANGE=false;                                \
	    make;                                        \
          fi;                                            \
          sleep 1;                                       \
          for i in ${EUSFILES} ; do                      \
	    if [ .$$i -ot ${EUSFILESDIR}/$$i.l ] ; then  \
	      CHANGE=true;                               \
	    fi                                           \
          done ;                                         \
        done

=== debian/changelog ===
ros-one-eus-qp (0.1.18-14jammy.20251023.0133) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Noda Shintaro <s-noda@jsk.t.u-tokyo.ac.jp>  Thu, 23 Oct 2025 01:33:17 +0000

ros-one-eus-qp (0.1.18-0jammy) jammy; urgency=high



 -- Noda Shintaro <s-noda@jsk.t.u-tokyo.ac.jp>  Mon, 09 Dec 2024 00:00:00 -0000

ros-one-eus-qp (0.1.17-0jammy) jammy; urgency=high



 -- Noda Shintaro <s-noda@jsk.t.u-tokyo.ac.jp>  Sun, 28 May 2023 00:00:00 -0000

ros-one-eus-qp (0.1.16-0jammy) jammy; urgency=high

  * check x::*display* is available before running graph-view (gnuplot) (#776 <https://github.com/jsk-ros-pkg/jsk_control/issues/776>)
  * ptmotiongen: no visualization / print if argument is nil. (#729 <https://github.com/jsk-ros-pkg/jsk_control/issues/729>)
  * [optmotiongen] inverse-kinematics for the discrete target (#728 <https://github.com/jsk-ros-pkg/jsk_control/issues/728>)
    
      * optmotiongen: add test of discrete-kinematics-configuration-task.
      * optmotiongen: update manual.pdf
      * optmotiongen: add manual for discrete target ik.
      * optmotiongen: add sample/sample-sqp-optimization-discrete-kinematics.l
      * optmotiongen: add sample function sample-arm-reach-ik-discrete-raw.
      * optmotiongen: add discrete-kinematics-configuration-task.l
      * optmotiongen: flatten for drawing kin coords list for support discrete-kinematics-configuration-task.
    
  * [optmotiongen] add sample to maximize contact force (#727 <https://github.com/jsk-ros-pkg/jsk_control/issues/727>)
    
      * optmotiongen: update manual.pdf
      * optmotiongen: add demo-jaxon-hand-force.l
      * optmotiongen: add :wrench-maximize-regular-vector to instant-config-task.
      * optmotiongen: add norm-regular-scale-coeff to instant-config-task.
      * optmotiongen: enable to set nil for print-status-interval and update-viewer-interval.
      * optmotiongen: add sqp-convergence-check and sqp-failure-callback.
      * optmotiongen: enable to set external-wrench-list.
    
  * [optmotiongen] visualize force fix (#722 <https://github.com/jsk-ros-pkg/jsk_control/issues/722>)
  * fix for test (#723 <https://github.com/jsk-ros-pkg/jsk_control/issues/723>)
    
      * optmotiongen: fix and reduce some tests because travis does not finish within 50 min.
      * optmotiongen: fix for visualize contact force in sample-sqp-optimization-trajectory.l.
      * optmotiongen: add functions for visualizing force and moment in playing motion
    
  * [eus_qp/optmotiongen] add target-posture-scale-list argument (#718 <https://github.com/jsk-ros-pkg/jsk_control/issues/718>)
    
      * optmotiongen: add target-posture-scale-list argument to instant-configuration-task :init method. support to change scale for each posture joint.
    
  * add demo rhp4b reach suitcase instant manip (#715 <https://github.com/jsk-ros-pkg/jsk_control/issues/715>)
  * [optmotiongen] fix gravity torque calculation (#714 <https://github.com/jsk-ros-pkg/jsk_control/issues/714>)
    
      * optmotiongen: update manual.pdf for gravity torque document.
      * optmotiongen: consider fixed link weight to calculate gravity torque. ToDo: The effect for centroid is not considered yet.
      * optmotiongen: update gravity-torque-jacobian calculation and document.
      * optmotiongen: add euslisp/demo/demo-rhp4b-torque-gradient.l
      * optmotiongen: test torque calculation with irtdyna result.
    
  * [optmotiongen] Rebase https://github.com/jsk-ros-pkg/jsk_control/pull/711 (#713 <https://github.com/jsk-ros-pkg/jsk_control/issues/713>)
    
      * optmotiongen: update manual.pdf for torque gradient update.
      * optmotiongen: update torque gradient calculation (get-contact-torque-jacobian function) and update document.
      * optmotiongen: add sample and test of torque gradient.
    
  * set adjacent regular scale as list format via :adjacent-regular-scale-list argument. add sample for that argument. (#708 <https://github.com/jsk-ros-pkg/jsk_control/issues/708>)
    
      * optmotiongen: add test of min/max angle of root virtual joint from ik wrapper.
      * optmotiongen: support min/max angle of root virtual joint from ik wrapper.
    
  * set adjacent regular scale as list format via :adjacent-regular-scale-list argument. add sample for that argument. (#708 <https://github.com/jsk-ros-pkg/jsk_control/issues/708>)
  * [eus_qp/optmotiongen] support min/max angle of root virtual joint (#709 <https://github.com/jsk-ros-pkg/jsk_control/issues/709>)
    
      * optmotiongen: add test of min/max angle of root virtual joint from ik wrapper.
      * optmotiongen: support min/max angle of root virtual joint from ik wrapper.
    
  * [eus_qp/optmotiongen] dynamic motion generation with bspline (#705 <https://github.com/jsk-ros-pkg/jsk_control/issues/705>)
    
      * [eus_qp/optmotiongen/manual] update manual.pdf for bspline-dynamic-configuration-task.
      * [eus_qp/optmotiongen/euslisp/contact-kinematics.l] add look-at-contact class and sample, test for that.
      * [eus_qp/optmotiongen] update sample and test for bspline-dynamic-configuration-task.
      * [eus_qp/optmotiongen/euslisp/demo,sample] move from demo to sample directory.
      * [eus_qp/optmotiongen/euslisp/sample,test] add option to supress graph generation for travis test.
      * [eus_qp/CMakeLists.txt] install optmotiongen directories.
      * [eus_qp/optmotiongen/euslisp/demo] rename hrp2 line face sample.
      * [eus_qp/optmotiongen/test] fix test name to use '_' instead of '-'. cf. http://wiki.ros.org/Names
      * [eus_qp/optmotiongen/euslisp/sample] use irtviewer :draw-floor and :floor-color methods instead of direct slots access.
      * [eus_qp/optmotiongen/test,euslisp/sample] add sample and test with irteus sample-robot.
      * [eus_qp/optmotiongen/doc] add README for bspline-dynamic-configuration-task.
      * [eus_qp/optmotiongen/euslisp/bspline-configuration-task.l] support delta-time argument in :generate-angle-vector-sequence.


=== debian/control ===
Source: ros-one-eus-qp
Section: misc
Priority: optional
Maintainer: Noda Shintaro <s-noda@jsk.t.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-one-catkin, ros-one-cmake-modules, ros-one-euslisp, ros-one-rostest
Homepage: 
Standards-Version: 3.9.2

Package: ros-one-eus-qp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-one-euslisp
Description: eus_qp is an interface of euslisp to solve qp problems with linear constraints.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-eus-qp//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-eus-qp 0.1.18-14jammy.20260220.2223

=== debian/changelog ===
ros-one-eus-qp (0.1.18-14jammy.20260220.2223) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Noda Shintaro <s-noda@jsk.t.u-tokyo.ac.jp>  Fri, 20 Feb 2026 22:23:13 +0000

## ros-one-eus-qp 0.1.18-14noble.20251023.0131

=== debian/changelog ===
ros-one-eus-qp (0.1.18-14noble.20251023.0131) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Noda Shintaro <s-noda@jsk.t.u-tokyo.ac.jp>  Thu, 23 Oct 2025 01:31:02 +0000

ros-one-eus-qp (0.1.18-0noble) noble; urgency=high



 -- Noda Shintaro <s-noda@jsk.t.u-tokyo.ac.jp>  Mon, 09 Dec 2024 00:00:00 -0000

ros-one-eus-qp (0.1.17-0noble) noble; urgency=high



 -- Noda Shintaro <s-noda@jsk.t.u-tokyo.ac.jp>  Sun, 28 May 2023 00:00:00 -0000

ros-one-eus-qp (0.1.16-0noble) noble; urgency=high

  * check x::*display* is available before running graph-view (gnuplot) (#776 <https://github.com/jsk-ros-pkg/jsk_control/issues/776>)
  * ptmotiongen: no visualization / print if argument is nil. (#729 <https://github.com/jsk-ros-pkg/jsk_control/issues/729>)
  * [optmotiongen] inverse-kinematics for the discrete target (#728 <https://github.com/jsk-ros-pkg/jsk_control/issues/728>)
    
      * optmotiongen: add test of discrete-kinematics-configuration-task.
      * optmotiongen: update manual.pdf
      * optmotiongen: add manual for discrete target ik.
      * optmotiongen: add sample/sample-sqp-optimization-discrete-kinematics.l
      * optmotiongen: add sample function sample-arm-reach-ik-discrete-raw.
      * optmotiongen: add discrete-kinematics-configuration-task.l
      * optmotiongen: flatten for drawing kin coords list for support discrete-kinematics-configuration-task.
    
  * [optmotiongen] add sample to maximize contact force (#727 <https://github.com/jsk-ros-pkg/jsk_control/issues/727>)
    
      * optmotiongen: update manual.pdf
      * optmotiongen: add demo-jaxon-hand-force.l
      * optmotiongen: add :wrench-maximize-regular-vector to instant-config-task.
      * optmotiongen: add norm-regular-scale-coeff to instant-config-task.
      * optmotiongen: enable to set nil for print-status-interval and update-viewer-interval.
      * optmotiongen: add sqp-convergence-check and sqp-failure-callback.
      * optmotiongen: enable to set external-wrench-list.
    
  * [optmotiongen] visualize force fix (#722 <https://github.com/jsk-ros-pkg/jsk_control/issues/722>)
  * fix for test (#723 <https://github.com/jsk-ros-pkg/jsk_control/issues/723>)
    
      * optmotiongen: fix and reduce some tests because travis does not finish within 50 min.
      * optmotiongen: fix for visualize contact force in sample-sqp-optimization-trajectory.l.
      * optmotiongen: add functions for visualizing force and moment in playing motion
    
  * [eus_qp/optmotiongen] add target-posture-scale-list argument (#718 <https://github.com/jsk-ros-pkg/jsk_control/issues/718>)
    
      * optmotiongen: add target-posture-scale-list argument to instant-configuration-task :init method. support to change scale for each posture joint.
    
  * add demo rhp4b reach suitcase instant manip (#715 <https://github.com/jsk-ros-pkg/jsk_control/issues/715>)
  * [optmotiongen] fix gravity torque calculation (#714 <https://github.com/jsk-ros-pkg/jsk_control/issues/714>)
    
      * optmotiongen: update manual.pdf for gravity torque document.
      * optmotiongen: consider fixed link weight to calculate gravity torque. ToDo: The effect for centroid is not considered yet.
      * optmotiongen: update gravity-torque-jacobian calculation and document.
      * optmotiongen: add euslisp/demo/demo-rhp4b-torque-gradient.l
      * optmotiongen: test torque calculation with irtdyna result.
    
  * [optmotiongen] Rebase https://github.com/jsk-ros-pkg/jsk_control/pull/711 (#713 <https://github.com/jsk-ros-pkg/jsk_control/issues/713>)
    
      * optmotiongen: update manual.pdf for torque gradient update.
      * optmotiongen: update torque gradient calculation (get-contact-torque-jacobian function) and update document.
      * optmotiongen: add sample and test of torque gradient.
    
  * set adjacent regular scale as list format via :adjacent-regular-scale-list argument. add sample for that argument. (#708 <https://github.com/jsk-ros-pkg/jsk_control/issues/708>)
    
      * optmotiongen: add test of min/max angle of root virtual joint from ik wrapper.
      * optmotiongen: support min/max angle of root virtual joint from ik wrapper.
    
  * set adjacent regular scale as list format via :adjacent-regular-scale-list argument. add sample for that argument. (#708 <https://github.com/jsk-ros-pkg/jsk_control/issues/708>)
  * [eus_qp/optmotiongen] support min/max angle of root virtual joint (#709 <https://github.com/jsk-ros-pkg/jsk_control/issues/709>)
    
      * optmotiongen: add test of min/max angle of root virtual joint from ik wrapper.
      * optmotiongen: support min/max angle of root virtual joint from ik wrapper.
    
  * [eus_qp/optmotiongen] dynamic motion generation with bspline (#705 <https://github.com/jsk-ros-pkg/jsk_control/issues/705>)
    
      * [eus_qp/optmotiongen/manual] update manual.pdf for bspline-dynamic-configuration-task.
      * [eus_qp/optmotiongen/euslisp/contact-kinematics.l] add look-at-contact class and sample, test for that.
      * [eus_qp/optmotiongen] update sample and test for bspline-dynamic-configuration-task.
      * [eus_qp/optmotiongen/euslisp/demo,sample] move from demo to sample directory.
      * [eus_qp/optmotiongen/euslisp/sample,test] add option to supress graph generation for travis test.
      * [eus_qp/CMakeLists.txt] install optmotiongen directories.
      * [eus_qp/optmotiongen/euslisp/demo] rename hrp2 line face sample.
      * [eus_qp/optmotiongen/test] fix test name to use '_' instead of '-'. cf. http://wiki.ros.org/Names
      * [eus_qp/optmotiongen/euslisp/sample] use irtviewer :draw-floor and :floor-color methods instead of direct slots access.
      * [eus_qp/optmotiongen/test,euslisp/sample] add sample and test with irteus sample-robot.
      * [eus_qp/optmotiongen/doc] add README for bspline-dynamic-configuration-task.
      * [eus_qp/optmotiongen/euslisp/bspline-configuration-task.l] support delta-time argument in :generate-angle-vector-sequence.


## ros-one-eus-qp 0.1.18-14noble.20260220.2235

=== debian/changelog ===
ros-one-eus-qp (0.1.18-14noble.20260220.2235) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Noda Shintaro <s-noda@jsk.t.u-tokyo.ac.jp>  Fri, 20 Feb 2026 22:35:07 +0000
